package bencode;

import java.util.*;
import java.io.*;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.nio.*;

/**
 * A set of utility methods to decode a bencoded array of byte into a Map.
 * integer are represented as Long, String as byte[], dictionnaries as Map, and
 * list as List.
 * 
 * @author TdC_VgA
 * @modify ޼ 2012.06.04
 */
public class BDecoder {

	private boolean recoveryMode;

	// TorrentļϢ
	public int pieceLength;

	public byte[] pieceHash;

	public byte[] infoHash;

	public ArrayList announceList;
	
	public ArrayList fileList;
	
	public String name;

	public class Files {
		
		public String path;
		public int length;

		public Files(int length) {
			this.length = length;
			this.path = null;
		}
	}

	// TrackerصھбϢ
	public int interval;

	public int complete;

	public int incomplete;

	public ArrayList peerList;

	public class Peers {

		public String peerId;
		public InetAddress ip;
		public int port;

		public Peers(int port) {
			this.port = port;
			this.ip = null;
			this.peerId = null;
		}
	}
	
	public BDecoder() {
		announceList = new ArrayList();
		fileList = new ArrayList();
		peerList = new ArrayList();
	}
	
	private ByteFormatter bf = new ByteFormatter();
	
	private void print(String objKey, Object obj) {

		if (obj instanceof Long) {
			
			// ȡtorrentļϢ
			if (objKey.equals("piece length")) {
				pieceLength = Integer.parseInt(obj.toString());
			} else if (objKey.equals("length")) {
				
				int length = Integer.parseInt(obj.toString());
				if (fileList.isEmpty()) {
					fileList.add(new Files(length));
				} else {
					int lastIndex = fileList.size() - 1;
					Files f = (Files)fileList.get(lastIndex);
					if (f.length == -1) {
						f.length = length;
					} else {
						fileList.add(new Files(length));
					}
				}
			} else if (objKey.equals("complete")) {
				complete = Integer.parseInt(obj.toString());
			} else if (objKey.equals("incomplete")) {
				incomplete = Integer.parseInt(obj.toString());
			} else if (objKey.equals("interval")) {
				interval = Integer.parseInt(obj.toString());
			} else if (objKey.equals("port")) {
				
				int port = Integer.parseInt(obj.toString());
				//System.out.println("port: " + port);
				
				if(peerList.isEmpty()) {
					peerList.add(new Peers(port));
				} else {
					int lastIndex = peerList.size() - 1;
					Peers p = (Peers) peerList.get(lastIndex);
					
					if (p.port == -1) {
						p.port = port;
					} else {
						peerList.add(new Peers(port));
					}
				}
			}
		} else if (obj instanceof byte[]) {
			
			byte[] byteArray = (byte[]) obj;
			
			if (objKey.equals("peers") || objKey.equals("values")) { //IPPortѹʽ
				
				byte[] bIp = new byte[4];
				System.arraycopy(byteArray, 0, bIp, 0, 4);
				
				InetAddress ip = null;
				try {
					ip = InetAddress.getByAddress(bIp);
				} catch (UnknownHostException e) {
					e.printStackTrace();
					return;
				}
				
				byte[] bPort = new byte[2];
				System.arraycopy(byteArray, 4, bPort, 0, 2);
				int port = bf.byteArrayToPort(bPort, 0);
				Peers p = new Peers(port);
				p.ip = ip;
				peerList.add(p);
				
			} else if (objKey.equals("nodes")) {
				// DHT response eigher nodes. 
				// The first four bytes is "IP", 
				// and fifth and sixth bytes is "PORT", 
				// and followed twenty bytes is "PEER ID";
			} else if (objKey.equals("pieces")) {
				pieceHash = byteArray;
			} else if (objKey.equals("announce")) {
				announceList.add(byteArray);
			} else if (objKey.equals("announce-list")) {
				if (!(announceList.contains(byteArray)))
					announceList.add(byteArray);
			} else if (objKey.equals("name")) {
				name = new String(byteArray);
			} else if (objKey.equals("path")) {
				
				String path = new String(byteArray);
				if(fileList.isEmpty()) {
					Files nf = new Files(-1);
					nf.path = path;
					fileList.add(nf);
				} else {
					int lastIndex = fileList.size() - 1;
					Files lf = (Files) fileList.get(lastIndex);
					
					if (lf.path == null) {
						lf.path = path;
					} else {
						Files nf = new Files(-1);
						nf.path = path;
						fileList.add(nf);
					}
				}
			} else if (objKey.equals("ip")) { // IPPortǷѹʽ
			
				InetAddress ip = null;
				try {
					ip = InetAddress.getByName(new String(byteArray));
				} catch (UnknownHostException e) {
					e.printStackTrace();
					return;
				}
				
				System.out.println(ip.getHostAddress().toString());
				
				if (peerList.isEmpty()) {
					Peers np = new Peers(-1);
					np.ip = ip;
					peerList.add(np);	
				} else {
					int lastIndex = peerList.size() - 1;
					Peers lp = (Peers) peerList.get(lastIndex);
					
					if (lp.ip == null) {
						lp.ip = ip;
					} else {
						Peers np = new Peers(-1);
						np.ip = ip;
						peerList.add(np);
					}
				}
				
			}  else if (objKey.equals("peer id")) {
				
				String peerId = new String(byteArray);
				System.out.println("peerId: " + peerId);
				
				if (peerList.isEmpty()) {
					Peers np = new Peers(-1);
					np.peerId = peerId;
					peerList.add(np);
				} else {
					int lastIndex = peerList.size() - 1;
					Peers lp = (Peers) peerList.get(lastIndex);
					
					if (lp.peerId == null) {
						lp.peerId = peerId;
					} else {
						Peers np = new Peers(-1);
						np.peerId = peerId;
						peerList.add(np);
					}
				}
			}
		} else if (obj instanceof String) {
			
		} else if (obj instanceof List) {
			List list = (List) obj;
			// writer.println(use_indent + "[");

			for (int i = 0; i < list.size(); i++) {
				// writer.print(indent + " (" + i + ") ");
				print(objKey, list.get(i));
			}
		} else {
			Map map = (Map) obj;
			Iterator it = map.keySet().iterator();

			while (it.hasNext()) {
				String mapKey = (String) it.next();

				if (mapKey.length() > 256) {
					// writer.print(indent + mapKey.substring(0, 256) + "... =
					// ");
				} else {
					// writer.print(indent + mapKey + " = ");
				}

				print(mapKey, map.get(mapKey));

				// info_hash
				if (mapKey.equals("info")) {
					SHA1Hasher sh = new SHA1Hasher();

					try {
						infoHash = sh.calculateHash(BEncoder.encode((Map) map
								.get(mapKey)));
					} catch (IOException e) {
						// TODO Զ catch 
						e.printStackTrace();
					}
				}
			}
		}
	}

	public void setRecoveryMode(boolean rm) {
		recoveryMode = rm;
	}

	private Map decode(ByteArrayInputStream bais) throws IOException {
		Object dis = decodeInputStream(bais, 0);

		if (dis == null) {
			throw (new IOException("BDecoder: zero length file"));
		} else if (!(dis instanceof Map)) {
			throw (new IOException("BDecoder: top level isn't a Map"));
		}
		return ((Map) dis);
	}

	public Map decodeByteArray(byte[] data) throws IOException {
		return (decode(new ByteArrayInputStream(data)));
	}

	public Map decode(byte[] data) throws IOException {
		return (new BDecoder().decodeByteArray(data));
	}

	public Map decodeStream(BufferedInputStream bis) throws IOException {
		Object dis = decodeInputStream(bis, 0);

		if (dis == null) {
			throw (new IOException("BDecoder: zero length file"));
		} else if (!(dis instanceof Map)) {
			throw (new IOException("BDecoder: top level isn't a Map"));
		}
		return ((Map) dis);
	}

	public Map decode(BufferedInputStream bis) throws IOException {
		return (new BDecoder().decodeStream(bis));
	}

	private long getNumberFromStream(InputStream bais, char parseChar)
			throws IOException {
		StringBuffer sb = new StringBuffer(3);

		int tempByte = bais.read();
		while ((tempByte != parseChar) && (tempByte >= 0)) {
			sb.append((char) tempByte);
			tempByte = bais.read();
		}

		// are we at the end of the stream?
		if (tempByte < 0) {
			return -1;
		}

		String str = sb.toString();
		// support some borked impls that sometimes don't bother encoding
		// anything

		if (str.length() == 0) {
			return (0);
		}

		return Long.parseLong(str);
	}

	private byte[] getByteArrayFromStream(InputStream bais) throws IOException {
		int length = (int) getNumberFromStream(bais, ':');

		if (length < 0) {
			return null;
		}

		// note that torrent hashes can be big (consider a 55GB file with 2MB
		// pieces
		// this generates a pieces hash of 1/2 meg

		if (length > 8 * 1024 * 1024) {
			throw (new IOException("Byte array length too large (" + length
					+ ")"));
		}

		byte[] tempArray = new byte[length];
		int count = 0;
		int len = 0;
		// get the string
		while (count != length
				&& (len = bais.read(tempArray, count, length - count)) > 0) {
			count += len;
		}

		if (count != tempArray.length) {
			throw (new IOException(
					"BDecoder::getByteArrayFromStream: truncated"));
		}

		return tempArray;
	}

	private Object decodeInputStream(InputStream bais, int nesting)
			throws IOException {
		if (nesting == 0 && !bais.markSupported()) {
			throw new IOException("InputStream must support the mark() method");
		}

		// set a mark
		bais.mark(Integer.MAX_VALUE);
		// read a byte
		int tempByte = bais.read();

		// decide what to do
		switch (tempByte) {
		case 'd':
			// create a new dictionary object
			Map tempMap = new HashMap();

			try {
				// get the key
				byte[] tempByteArray = null;
				while ((tempByteArray = (byte[]) decodeInputStream(bais,
						nesting + 1)) != null) {

					// decode some more
					Object value = decodeInputStream(bais, nesting + 1);
					// keys often repeat a lot - intern to save space
					String key = StringInterner.intern(tempByteArray);

					if (key == null) {
						CharBuffer cb = Constants.BYTE_CHARSET
								.decode(ByteBuffer.wrap(tempByteArray));
						key = new String(cb.array(), 0, cb.limit());
						key = StringInterner.intern(key);
					}
					tempMap.put(key, value);
				}

				bais.mark(Integer.MAX_VALUE);
				tempByte = bais.read();
				bais.reset();

				if (nesting > 0 && tempByte == -1) {
					throw (new IOException(
							"BDecoder: invalid input data, 'e' missing from end of dictionary"));
				}
			} catch (Throwable e) {
				if (!recoveryMode) {
					if (e instanceof IOException) {
						throw ((IOException) e);
					}
					// throw(new
					// IOException(Debug.getNestedExceptionMessage(e)));
				}
			}
			// return the map
			return tempMap;

		case 'l':
			// create the list
			List tempList = new ArrayList();

			try {
				// create the key
				Object tempElement = null;
				while ((tempElement = decodeInputStream(bais, nesting + 1)) != null) {
					// add the element
					tempList.add(tempElement);
				}

				bais.mark(Integer.MAX_VALUE);
				tempByte = bais.read();
				bais.reset();
				if (nesting > 0 && tempByte == -1) {
					throw (new IOException(
							"BDecoder: invalid input data, 'e' missing from end of list"));
				}
			} catch (Throwable e) {
				if (!recoveryMode) {
					if (e instanceof IOException) {
						throw ((IOException) e);
					}
					// throw( new IOException(
					// Debug.getNestedExceptionMessage(e)));
				}
			}
			// return the list
			return tempList;

		case 'e':
		case -1:
			return null;

		case 'i':
			return new Long(getNumberFromStream(bais, 'e'));

		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			// move back one
			bais.reset();
			// get the string
			return getByteArrayFromStream(bais);

		default:
			int rem_len = bais.available();
			if (rem_len > 256) {
				rem_len = 256;
			}
			byte[] rem_data = new byte[rem_len];
			bais.read(rem_data);

			throw (new IOException("BDecoder: unknown command '" + tempByte
					+ ", remainder = " + new String(rem_data)));
		}
	}

	/**
	 * Converts any byte[] entries into UTF-8 strings
	 * 
	 * @param map
	 * @return
	 */
	public List decodeStrings(List list) {
		if (list == null) {
			return (null);
		}

		for (int i = 0; i < list.size(); i++) {
			Object value = list.get(i);

			if (value instanceof byte[]) {
				try {
					String str = new String((byte[]) value, "UTF-8");
					list.set(i, str);
				} catch (Throwable e) {
					// Debug.printStackTrace(e);
				}
			} else if (value instanceof Map) {
				decodeStrings((Map) value);
			} else if (value instanceof List) {
				decodeStrings((List) value);
			}
		}
		return (list);
	}

	public Map decodeStrings(Map map) {
		if (map == null) {
			return (null);
		}

		Iterator it = map.entrySet().iterator();

		while (it.hasNext()) {
			Map.Entry entry = (Map.Entry) it.next();
			Object value = entry.getValue();

			if (value instanceof byte[]) {
				try {
					entry.setValue(new String((byte[]) value, "UTF-8"));

				} catch (Throwable e) {

					// Debug.printStackTrace(e);
				}
			} else if (value instanceof Map) {
				decodeStrings((Map) value);
			} else if (value instanceof List) {
				decodeStrings((List) value);
			}
		}
		return (map);
	}

	private void print(Object obj) {
		print("", obj);
	}

	public void print(File file) {
		try {
			setRecoveryMode(false);
			print(decodeStream(new BufferedInputStream(
					new FileInputStream(file))));

			// BDecoder decoder = new BDecoder();
			// decoder.setRecoveryMode(false);
			// decoder.print(decoder.decodeStream(new BufferedInputStream(new
			// FileInputStream(f))));
		} catch (Throwable e) {
			e.printStackTrace();
		}
	}

	public void print(byte[] buf) {
		try {
			setRecoveryMode(false);
			print(decodeStream(new BufferedInputStream(
					new ByteArrayInputStream(buf))));

			// BDecoder decoder = new BDecoder();
			// decoder.setRecoveryMode(false);
			// decoder.print(decoder.decodeStream(new BufferedInputStream(new
			// ByteArrayInputStream(buf))));
		} catch (IOException e) {
			return;
		} catch (Throwable e) {
			e.printStackTrace();
		}
	}
}
