package component;

import java.util.LinkedList;
import java.net.InetSocketAddress;

public class Neighbor {
	
	public boolean isOutgoing = false;
	
	public final InetSocketAddress address;

	public String peerId = null;

	public final byte[] bitfield;

	public volatile int amChoking = 1;// Լھ
	
	//public volatile int amChoking = 0;

	public volatile int amInterested = 0;// ԼھӸȤ

	public volatile int peerChoking = 1;// ھԼ
	
	//public volatile int peerChoking = 0;

	public volatile int peerInterested = 0;// ھӶԼȤ

	public volatile int uploadRate = 0;// ھϴ

	public volatile int downloadRate = 0;// ھ

	public long sendTime = 0;// Լھӵaliveʱ
	
	public long recieveTime = 0;// ھӶԼaliveʱ
	
	public int requestNum = 0;
	
	private final int pieceNum;
		
	public final LinkedList sendingQueue = new LinkedList();

	public Neighbor(int pieceNum, InetSocketAddress address) {

		this.address = address;

		this.pieceNum = pieceNum;
		int bitfieldLen = pieceNum / 8;
		if (pieceNum % 8 != 0) {
			bitfieldLen++;
		}
		this.bitfield = new byte[bitfieldLen];
	}

	public void setBitfield(int pieceIndex) {
		int bitIndex = pieceIndex / 8;
		int bitOffset = pieceIndex % 8;
		bitfield[bitIndex] = (byte) ((bitfield[bitIndex] | (byte) (128 >> bitOffset)));
	}

	public boolean isCompleted() {

		for (int i = 0; i < pieceNum; i++) {
			int bitIndex = i / 8;
			int bitOffset = i % 8;

			if ((bitfield[bitIndex] & (byte) (128 >> bitOffset)) == 0) {
				return false;
			}
		}
		return true;
	}

	public boolean becomeInterested(byte[] clientBitfield) {

		// ԭȤfalse
		if (amInterested == 1)
			return false;

		 /*
		 int length = clientBitfield.length;
		 for(int i = 0; i < length; i++) {
		 System.out.print(clientBitfield[i]);
		 }
		 //*/

		 /*
		 int length = bitfield.length;
		 for(int i = 0; i < length; i++) {
		 System.out.print(bitfield[i]);
		 }
		 //*/

		for (int i = 0; i < pieceNum; i++) {

			int bitIndex = i / 8;
			int bitOffset = i % 8;

			if ((bitfield[bitIndex] & (byte) (128 >> bitOffset)) != 0
					&& (clientBitfield[bitIndex] & (byte) (128 >> bitOffset)) == 0) {
				amInterested = 1;
				return true;
			}
		}
		return false;
	}

	public boolean becomeNotInterested(byte[] clientBitfield) {

		// ԭȤfalse
		if (amInterested == 0)
			return false;

		for (int i = 0; i < pieceNum; i++) {

			int bitIndex = i / 8;
			int bitOffset = i % 8;

			if ((bitfield[bitIndex] & (byte) (128 >> bitOffset)) != 0
					&& (clientBitfield[bitIndex] & (byte) (128 >> bitOffset)) == 0) {
				amInterested = 0;
				return false;
			}
		}
		return true;
	}
}
