package protocol;

import java.util.concurrent.TimeUnit;

import component.*;

public class Main {

	public static void main(String[] args) {
		
		System.out.println("start to decode the torrent file...");
		DecodeTorrentTask dtt = new DecodeTorrentTask("a.torrent");
		Component c = (Component)dtt.call();
		System.out.println("component has been initialized...");
		if(c == null) {
			System.out.println("compoennt is null...");
			return;
		}	
		
		TcpServerTask tst = new TcpServerTask(c);
		TcpClientTask tct = new TcpClientTask(c);
		ReadMessageTask rmt = new ReadMessageTask(c);
		WriteMessageTask wmt = new WriteMessageTask(c);
		HandleMessageTask hmt = new HandleMessageTask(c);
		
		System.out.println("start a tcp server task...");
		c.exec.execute(tst);
		System.out.println("start a tcp client task...");
		c.exec.execute(tct);
		System.out.println("start a read message task...");
		c.exec.execute(rmt);
		System.out.println("start a write message task...");
		c.exec.execute(wmt);
		System.out.println("start a handle message task...");
		c.exec.execute(hmt);
		
		WriteFileTask wft = new WriteFileTask(c);
		CheckStateTask cst = new CheckStateTask(c);
		
		System.out.println("start a write file task...");
		c.stpe.scheduleAtFixedRate(wft, 15, 5, TimeUnit.SECONDS);
		System.out.println("start a check state task...");
		c.stpe.scheduleAtFixedRate(cst, 5, 5, TimeUnit.SECONDS);
		
		c.startTime = System.currentTimeMillis();
	}
}
