package component;

import java.util.LinkedList;
import java.util.ArrayList;
import java.util.concurrent.Executor;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledThreadPoolExecutor;
import java.util.concurrent.LinkedBlockingQueue;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.net.InetAddress;
import java.net.UnknownHostException;

public class Component {
	
	public long startTime = 0;
	
	public long endTime = 0;
	
	public final LinkedBlockingQueue receivingQueue = new LinkedBlockingQueue();
	
	public final LinkedList addressQueue = new LinkedList();
	
	public final LinkedList pendingQueue = new LinkedList();
	
	public final LinkedList writingQueue = new LinkedList();
	
	public final LinkedList readingQueue = new LinkedList();
	
	public final LinkedList neighborList = new LinkedList();
	
	public final ArrayList trackerList = new ArrayList();
	
    public final LinkedBlockingQueue readers = new LinkedBlockingQueue();
    
    public final LinkedBlockingQueue writers = new LinkedBlockingQueue();
	
	public final Client client;

	public final FileInfo fileInfo;
	
	public final RandomAccessFile[] randomAccessFile;
	
	public volatile int checkCycle = 0;
	
	public volatile int addressIndex = 0;
	
	public final Executor exec = Executors.newCachedThreadPool();
	
	public final ScheduledThreadPoolExecutor stpe = new ScheduledThreadPoolExecutor(10);
	
	public Component(Client client, FileInfo fileInfo, RandomAccessFile[] raf) {

		this.client = client;
		this.fileInfo = fileInfo;
		this.randomAccessFile = raf;
	
	}
	
	public void write(String s) {
		
		String fileName = null;
		try {
			InetAddress ip = InetAddress.getLocalHost();
			fileName = ip.getHostAddress() + ".txt";
		} catch (UnknownHostException e) {
			e.printStackTrace();
			return;
		}
		System.out.println("fileName: " + fileName);
		
		BufferedWriter bw;
		try {
			bw = new BufferedWriter(new FileWriter(fileName, true));
			
			bw.write(s);
			bw.newLine();
			bw.close();
		}
		catch(FileNotFoundException e) {
			System.out.println("Error: unable to open file for writing.");
		}
		catch(IOException e) {
			System.out.println("Error: unable to write file.");
		}
	}
}
